Subject: Device mapper modalias

From: Danny Milosavljevic <[email-masked]>
Date: Wed, 28 Feb 2018 04:03:00 +0100

Hi Ludo,

On Tue, 27 Feb 2018 22:15:31 +0100
[email-masked] (Ludovic Courtès) wrote:

> >>   1. ‘device-module-aliases’ returns the empty list for /dev/dm-0, which
> >>      is a LUKS device on my laptop.  I’m not sure what it would take to
> >>      have it return “dm-crypt”, etc.  Same for RAID devices.  
> >
> > Hmm...  I don't know either.  
> 
> I browsed kmod in search of code that does that but couldn’t find it.
> Do you know of another source for such things?

The device mapper for logical devices (/dev/mapper/control) provides ioctls.

scheme@(guile-user)> (device-module-aliases "/dev/mapper/control")
$2 = ()

Sigh...

Also, Linux dm.c lazily modprobes "dm-%s", target_type.

To get target_type as root (warning: getting the table status loads the module):

#include <sys/sysmacros.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <assert.h>
#include <linux/dm-ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <string.h>

static void xdm_init(struct dm_ioctl* header, unsigned dev, off_t datastart, size_t allsize, unsigned flags) {
        memset(header, 0, sizeof(header));
        header->version[0] = 4;
        header->version[1] = 0;
        header->version[2] = 0;
        header->data_size = allsize;
        header->data_start = datastart;
        header->flags = flags;
        header->dev = dev;
}

struct xdm_devicelist {
        struct dm_ioctl header;
        struct dm_name_list items[100];
};

struct xdm_tablestatus {
        struct dm_ioctl header;
        struct dm_target_spec items[100];
};

int main() {
        int controlfd;
        controlfd = open("/dev/mapper/control", O_RDWR);

	// Retrieve dev major/minor
        struct xdm_devicelist devicelist;
        xdm_init(&devicelist.header, 0, offsetof(struct xdm_devicelist, items), sizeof(devicelist), 0);
        if (ioctl(controlfd, DM_LIST_DEVICES, &devicelist) == -1)
                abort();
        printf("devicelist %s %u\n", devicelist.items[0].name, (unsigned) devicelist.items[0].dev);

	// Get target_type of that device
        struct xdm_tablestatus tablestatus;
        xdm_init(&tablestatus.header, devicelist.items[0].dev, offsetof(struct xdm_tablestatus, items), sizeof(tablestatus), DM_STATUS_TABLE_FLAG);
        tablestatus.header.dev = devicelist.items[0].dev;
        if (ioctl(controlfd, DM_TABLE_STATUS, &tablestatus) == -1) {
                perror("b");
                abort();
        }
        assert(tablestatus.header.target_count == 1);
        printf("target_type %s\n", tablestatus.items[0].target_type); // prints "crypto", hence we should modprobe "dm-crypto".
        printf("XXX %u\n", makedev(253, 0)); // The same
        return 0;
}

Alternatively, there's even a dm-uevent.c for sysfs AND we have enabled it AND it's supposed
to report DM_TARGET - but I can't see it.  Maybe it only does that for events and not for state.

Alternatively, there's also this:

$ udevadm info -q all /dev/dm-0

... which has quite a lot of the info, but not the module name.